// ===============================================================
// udemo.UZHandler:  Native class that handles decompressing and saving UZ Files.
// making the tcp/ip subclass native would be more logical.. however, I lack the ipdrv headers and libs :/
// ===============================================================

class UZHandler expands Object
native;

//downloading pointers (C++ only)
var const int UzAr; // C++ FArchive*. (as downloading)
var const int UzDeCompAr; // C++ FArchive*. (decompressed)
//save information:
var const string FileName; //temporary during decompress cycle
var GUID FileGUID; //required file's GUID!
var int FileGen; //required file's generation   Note: if -1, then ignore guid/gen checks (int file)

native final function Append (byte count, byte B[255]);  //append a byte array to the uzar.
//try to save a file either in cache or in the main paths.
//if cache is true, will move any file already found!  (guid updates)
//if false, will simply overwrite the current filename! (generation update)
// error codes returned:
// 0: Successful
// 1: generation older than demo (warning only)
// 2: GUID mismatch
// 3: unknown saving error
native final function int SaveFile (bool bInCache);
native final function ForceSave(bool bInCache); //force save if gen mismatch

defaultproperties {
}
