#include "udemoprivate.h"

#define NAMES_ONLY
#define AUTOGENERATE_NAME(name) UDEMO_API FName UDEMO_##name;
#define AUTOGENERATE_FUNCTION(cls,idx,name)/* IMPLEMENT_FUNCTION(cls,idx,name)*/
#include "udemoClasses.h"
#undef AUTOGENERATE_FUNCTION
#undef AUTOGENERATE_NAME
#undef NAMES_ONLY
IMPLEMENT_PACKAGE (udemo);
void RegisterNames()
{
	static INT Registered=0;
	if(!Registered++)
	{
		#define NAMES_ONLY
		#define AUTOGENERATE_NAME(name) extern UDEMO_API FName UDEMO_##name; UDEMO_##name=FName(TEXT(#name),FNAME_Intrinsic);
		#define AUTOGENERATE_FUNCTION(cls,idx,name)
		#include "udemoClasses.h"
		#undef DECLARE_NAME
		#undef NAMES_ONLY
	}
}
IMPLEMENT_CLASS(Uudnative);


void Uudnative::execDemoActive (FFrame& Stack, RESULT_DECL){ //checks C only accessable pointers
	guard (Uudnative::execDemoActive); 
	P_GET_OBJECT(ULevel,mylevel); //xlevel
	P_FINISH;
	if (mylevel==NULL||mylevel->DemoRecDriver==NULL)
		*(BYTE*)Result=0;
	else if (!mylevel->DemoRecDriver->ServerConnection) //no server connection = recording.
		*(BYTE*)Result=1;
	else
		*(BYTE*)Result=2;	
	unguard;
}
IMPLEMENT_FUNCTION (Uudnative,-1,execDemoActive); //verifies if a demo is playing.

void Uudnative::execRename (FFrame& Stack, RESULT_DECL){ //rename a demo
guard (Uudnative::execRename); 
P_GET_STR(myfile);
P_GET_STR(mynewfile);
P_FINISH;

	if (DemoDriver){
		DemoDriver->LowLevelDestroy();
		UDReader * Reader=(UDReader*)DemoDriver->Notify;
		Reader->Destroy();

	}
/*
INT i = myfile.Caps().InStr(TEXT(".DEM"));
if( i != -1)
	myfile = myfile.Left(i);
myfile += TEXT(".dem");

i = mynewfile.Caps().InStr(TEXT(".DEM"));
if( i != -1)
	mynewfile = mynewfile.Left(i);
myfile += TEXT(".dem");
*/
const TCHAR *p=*myfile;
const TCHAR *o=*mynewfile;
int thing=rename(TCHAR_TO_ANSI(p),TCHAR_TO_ANSI(o) );
//int thing=_trename(p,o);
GLog->Logf(TEXT("did rename res=%i; error=%i"),thing,errno);
/*if (thing!=0)
      GLog->Logf(TEXT("Failed to rename %s to %s"),*myfile,*mynewfile);
else{
      GLog->Logf(TEXT("Successfully renamed %s to %s"),*myfile,*mynewfile);
	  *(UBOOL*)Result=1; //true
}*/
if (thing==0)
	*(UBOOL*)Result=1; //true
//GLog->Logf(TEXT("post rename"));
unguard;
}
IMPLEMENT_FUNCTION (Uudnative,-1,execRename); //renaming filez.
void Uudnative::execkill (FFrame& Stack, RESULT_DECL){ //delete a demo
guard (Uudnative::execkill); 
P_GET_STR(myfile);
P_FINISH;
if (DemoDriver){ //close any filear
		DemoDriver->LowLevelDestroy();
		UDReader * Reader=(UDReader*)DemoDriver->Notify;
		Reader->Destroy();

	}
INT i = myfile.Caps().InStr(TEXT(".DEM"));
if( i != -1)
	myfile = myfile.Left(i);
myfile += TEXT(".dem");
const TCHAR *p=*myfile;
if( remove(TCHAR_TO_ANSI(p))  == -1 ){
	if (errno==13)
      GWarn->Logf(TEXT("Failed to delete %s READ ONLY FILE"),FString(p));
	else if (errno==2)
		 GWarn->Logf(TEXT("Failed to delete %s DOES NOT EXIST"),FString(p));
	else
		GWarn->Logf(TEXT("Failed to delete %s UNKNOWN ERROR"),FString(p));
}
else{
      GLog->Logf(TEXT("Successfully removed %s"),myfile);
	  *(UBOOL*)Result=1; //true
}

unguard;
}
IMPLEMENT_FUNCTION (Uudnative,-1,execkill); //removing filez

//gives base directory:
void Uudnative::execBasePath (FFrame& Stack, RESULT_DECL){ 
	guard (Uudnative::execBasePath); 
	P_FINISH;
	*(FString*)Result = appBaseDir();
	unguard;
}
IMPLEMENT_FUNCTION (Uudnative,-1,execBasePath);

void Uudnative::execgetdemo (FFrame& Stack, RESULT_DECL){ 
static struct _finddata_t f;
static long hFile;
	guard (Uudnative::execgetdemo);  
	P_GET_STR(path); 
        P_FINISH;
 		if (path!=TEXT("")){ //refresh
		 	// Init if not already done.
			RegisterNames();
			path+=TEXT("*.dem");
			hFile=_findfirst(TCHAR_TO_ANSI(*path), &f);
		 if (hFile==-1)
			*(FString*)Result = FString::Printf(TEXT(""));
		 else{
		 	*(FString*)Result = FString::Printf(TEXT("%s/"),FString(ANSI_TO_TCHAR(f.name)));
//		 	GLog->Logf(TEXT("As F: %f  As U: %u, AS X: %x, as I: %i"),(f.size+512)/1024,(f.size+512)/1024,(f.size+512)/1024,(f.size+512)/1024);
			*(FString*)Result+=FString::Printf(TEXT("%u"),(f.size+512)/1024);
		 }
		}
		else{
			if (_findnext(hFile, &f)==0){
				*(FString*)Result = FString::Printf(TEXT("%s/"),FString(ANSI_TO_TCHAR(f.name)));
				*(FString*)Result+=FString::Printf(TEXT("%u"),(f.size+512)/1024);
			}
			else {
				_findclose(hFile);
				*(FString*)Result = FString::Printf(TEXT(""));
				GLog->Logf(TEXT("UDEMO: Successfully got list of demos"));
			}
		}
	unguard;
}
IMPLEMENT_FUNCTION (Uudnative,-1,execgetdemo); //demo name grabbing
void Uudnative::execDemoRead (FFrame& Stack, RESULT_DECL)
{ 
	guard (Uudnative::execDemoRead);  
	UDReader * Reader;
	P_GET_STR(myfile);
	P_GET_OBJECT(ULevel,mylevel); //xlevel
	P_FINISH;
	FURL URL(NULL, *myfile, TRAVEL_Absolute);
	
	URL.Map += TEXT(".dem");
	
	debugf( TEXT("Opening demo driver to read demo file '%s'"), *URL.Map );
	
	//UGameEngine* GameEngine = CastChecked<UGameEngine>( mylevel->Engine );
	if (DemoDriver){
		DemoDriver->LowLevelDestroy();
		Reader=(UDReader*)DemoDriver->Notify;
		Reader->Destroy();

	}
	Reader= new UDReader( CastChecked<UGameEngine>( mylevel->Engine ), URL, this);

	if( !Reader->DemoRecDriver)
	{
		GWarn->Logf( TEXT("Failed to read demo: %s"), URL.Map );
		delete Reader;
	}
	else
		DemoDriver=(UDemoRecDriver*) Reader->DemoRecDriver;
	unguard;

}
IMPLEMENT_FUNCTION (Uudnative,-1,execDemoRead);

void Uudnative::execDispatchTick (FFrame& Stack, RESULT_DECL)
{ 
	guard (Uudnative::execDispatchTick);
	P_GET_FLOAT(DeltaTime);
	P_FINISH;
	if (DemoDriver){
	// Update demo recording driver.
		UNetConnection*	ServerConnection=DemoDriver->ServerConnection;
		DemoDriver->TickDispatch( DeltaTime );
		if (DemoDriver)
			DemoDriver->TickFlush();
		else if (ServerConnection){
			ServerConnection->State = USOCK_Closed;
		//	ServerConnection->Destroy();
		}
		/*if (DemoDriver&&DemoDriver->FileAr&&(DemoDriver->FileAr->AtEnd() || DemoDriver->FileAr->IsError())){
			debugf(L"destroying driver.  demoended!");
			DemoDriver->LowLevelDestroy();
			UDReader * Reader =(UDReader*)DemoDriver->Notify;
			Reader->Destroy();
		}*/
			
	}
	unguard;
}
IMPLEMENT_FUNCTION (Uudnative,-1,execDispatchTick);

//converts GUID to string.
void Uudnative::execGUIDString (FFrame& Stack, RESULT_DECL){ 
	guard (Uudnative::execGUIDString);
	P_GET_STRUCT(FGuid,inGUID);
	P_FINISH;
	*(FString*)Result = inGUID.String();
	unguard;
}
IMPLEMENT_FUNCTION (Uudnative,-1,execGUIDString);

//writes demo info.
void Uudnative::execWriteDemoInfo (FFrame& Stack, RESULT_DECL){ 
	guard (Uudnative::execWriteDemoInfo); 
	P_GET_STR(DemoFilename);
	P_GET_STR(Contents);
	P_FINISH;
	DemoFilename+=TEXT("Info.TXT");
	if (appSaveStringToFile(Contents,*DemoFilename,GFileManager))
	{
		GLog->Logf(TEXT("Sucessfully wrote to '%s'"), *DemoFilename );
		*(UBOOL*)Result = 1;
	}
	else
		GLog->Logf(TEXT("Unknown error while writing to'%s'"), *DemoFilename );

	unguard;
}
IMPLEMENT_FUNCTION (Uudnative,-1,execWriteDemoInfo);

//checks for mismatches
void Uudnative::execIsMisMatch (FFrame& Stack, RESULT_DECL){ 
	guard (Uudnative::execIsMisMatch); 
	P_GET_STR(FileName);
	P_GET_STRUCT(FGuid,PackageGUID); //guid
	P_GET_INT(Gen);
//	P_GET_INT_REF(FSize); //this is out var
	P_FINISH;
	if (FileName==TEXT("")){ //um??
	//	GLog->Logf(TEXT("null filename!"));
		*(BYTE*)Result=0;
		return;
	}
	//load linker and stuff.
	BeginLoad(); 	
	ULinkerLoad* Linker = GetPackageLinker( NULL, *FileName, LOAD_None, NULL, &PackageGUID); //load with GUID!
	if (!Linker){ //fail load
		//GLog->Logf(TEXT("WTF? %s refused to load!"),*FileName);
		*(BYTE*)Result=3;
		EndLoad();
		return;
	}
	else if ((Linker->Summary.Guid) != PackageGUID) //mismatch!
		*(BYTE*)Result=2;
	else if (Linker->Summary.Generations.Num() < Gen) //user is using outdated file!
		*(BYTE*)Result=1;
	else
		*(BYTE*)Result=0;
//	*FSize=GFileManager->FileSize(*Linker->Filename);
	//GLog->Logf(TEXT("Demo Manager. While reading %s, actually read %s (size of %i)"), *FileName,*Linker->Filename,*FSize );
	//garbage collect should get rid of everything else :)
	EndLoad();

  unguard;
}
IMPLEMENT_FUNCTION (Uudnative,-1,execIsMisMatch);

//hack to find root window:
void Uudnative::execFindViewPort (FFrame& Stack, RESULT_DECL){ 
		guard (Uudnative::execFindViewPort); 
		P_FINISH;	
		*(UPlayer**)Result = UTexture::__Client->Viewports(0); //thx mongo! (amazing this works)
		unguard;
}
IMPLEMENT_FUNCTION (Uudnative,-1,execFindViewPort);